using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Reflection;

namespace WindowsApplication6
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button cmdButton1;
		private System.Windows.Forms.Button cmdButton2;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			// Required for Windows Form Designer support
			InitializeComponent();
		}

		private void cmdButton1_Click(object sender, System.EventArgs e)
		{
			//Assembly laden
			Assembly l_Assembly 
				= Assembly.LoadFrom(@"..\..\..\ClassLibrary6\bin\Debug\ClassLibrary6.dll");

			//Die Klasse, auf die zugegriffen werden soll, ermitteln
			Type l_Type = l_Assembly.GetType("ClassLibrary6.Class1");

			//Instanz der Klasse erstellen
			object l_Instance = Activator.CreateInstance(l_Type);

			//MethodInfo-Objekt fr die gewnschte Funktion erstellen 
			//und Funktion in der KlassenInstanz ber Invoke aufrufen
			MethodInfo l_MethodInfo = l_Type.GetMethod("ShowMessage", BindingFlags.Instance | BindingFlags.NonPublic);
			l_MethodInfo.Invoke(l_Instance, new object[]{"Hello Reflection World!"});
		}

		private void cmdButton2_Click(object sender, System.EventArgs e)
		{
			//Assembly laden
			Assembly l_Assembly 
				= Assembly.LoadFrom(@"..\..\..\ClassLibrary6\bin\Debug\ClassLibrary6.dll");

			//Die Klasse, auf die zugegriffen werden soll, ermitteln
			Type l_Type = l_Assembly.GetType("ClassLibrary6.Class2");

			//Privaten Constructor ermitteln und Instanz der Klasse erstellen !!!!
			ConstructorInfo l_ConstructorInfo = l_Type.GetConstructor(BindingFlags.Instance | BindingFlags.NonPublic, null, new Type[0], null);
			object l_Instance = l_ConstructorInfo.Invoke(new object[0]);

			//MethodInfo-Objekt fr die gewnschte Funktion erstellen 
			//und Funktion in der KlassenInstanz ber Invoke aufrufen
			MethodInfo l_MethodInfo = l_Type.GetMethod("ShowMessage2", BindingFlags.Instance | BindingFlags.NonPublic);
			l_MethodInfo.Invoke(l_Instance, new object[]{"Hello Reflection World 2!"});
		}

		#region Dispose
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}
		#endregion

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.cmdButton1 = new System.Windows.Forms.Button();
			this.cmdButton2 = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// cmdButton1
			// 
			this.cmdButton1.Location = new System.Drawing.Point(52, 36);
			this.cmdButton1.Name = "cmdButton1";
			this.cmdButton1.Size = new System.Drawing.Size(140, 36);
			this.cmdButton1.TabIndex = 0;
			this.cmdButton1.Text = "Aufruf ber Reflection";
			this.cmdButton1.Click += new System.EventHandler(this.cmdButton1_Click);
			// 
			// cmdButton2
			// 
			this.cmdButton2.Location = new System.Drawing.Point(52, 84);
			this.cmdButton2.Name = "cmdButton2";
			this.cmdButton2.Size = new System.Drawing.Size(140, 36);
			this.cmdButton2.TabIndex = 1;
			this.cmdButton2.Text = "Aufruf ber Reflection mit privatem Constructor";
			this.cmdButton2.Click += new System.EventHandler(this.cmdButton2_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(244, 162);
			this.Controls.Add(this.cmdButton2);
			this.Controls.Add(this.cmdButton1);
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "Form1";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Form1";
			this.ResumeLayout(false);

		}
		#endregion

		#region Main
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}
		#endregion

	}
}
